//+------------------------------------------------------------------+
//|                                                        Trend.mq4 |
//|                                      Copyright  2010, DimDimych |
//|                                                     dm34@mail.ru |
//+------------------------------------------------------------------+
#property copyright "DimDimych"
#property link      "dm34@mail.ru"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 Blue
#property indicator_color4 Gold
#property indicator_color5 White
//---- input parameters

extern int Bands_Period       = 20;
extern double Bands_Deviation = 2;
extern int Power_Period       = 13;
extern int range              = 15; //- 
extern int Continue_Priod     = 7;
extern int CountBars          = 300;
extern bool histo             = false;
extern bool arrows            = true;
extern bool SoundAlert        = true;
//---- buffers
double value[];
double value2[];
double flat[],temp[],up[],dn[];
string sPrefix;int tt;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//   string short_name;
//---- indicator line
   IndicatorBuffers(6);
 if(histo)  
  {
   SetIndexStyle(0, DRAW_HISTOGRAM,0,2);
   SetIndexStyle(1, DRAW_HISTOGRAM,0,2);
  } 
 else
  {
   SetIndexStyle(0, DRAW_LINE,0,2);
   SetIndexStyle(1, DRAW_LINE,0,2);  
  }
   SetIndexBuffer(0, value);
   SetIndexBuffer(1, value2);

   SetIndexBuffer(2, up);
   SetIndexBuffer(3, dn);   
   SetIndexStyle(2,DRAW_ARROW,0,1);
   SetIndexStyle(3,DRAW_ARROW,0,1);
   SetIndexArrow(2,108);
   SetIndexArrow(3,108);
   SetIndexStyle(4, DRAW_LINE,0,8);
   SetIndexBuffer(4, flat);      
   SetIndexBuffer(5, temp);    
//---- name for DataWindow and indicator subwindow label
   sPrefix ="Trend (" + Bands_Period + ", " + DoubleToStr(Bands_Deviation,2) + " flat: "+range+ "p.)";
   IndicatorShortName(sPrefix);
   SetIndexLabel(0, "iTrend1 (" + Bands_Period + ", " + DoubleToStr(Bands_Deviation,2) + ")");
   SetIndexLabel(1, "iTrend2 (" + Bands_Period + ", " + DoubleToStr(Bands_Deviation,2) + ")");      
//----
   SetIndexDrawBegin(0, Bars - CountBars + Bands_Period + 1);
   SetIndexDrawBegin(1, Bars - CountBars + Bands_Period + 1);
//----

   return(0);
  }
//--------------
void DelOb()
{
    int n = ObjectsTotal();
    for (int i = n - 1; i >= 0; i--) 
    {
     string sName = ObjectName(i);
	  if (StringFind(sName, sPrefix) == 0) 
	  {
	    ObjectDelete(sName);
	  }
    }
} 
//--------------  
  
void deinit()
{
DelOb();
}  
//----------------------------------------------------------------------
void DrawAr(string ssName, int i)
{
    
    string sName=sPrefix+" "+ssName+" "+ TimeToStr(Time[i],TIME_DATE|TIME_MINUTES);
    //ObjectDelete(sName);    
    ObjectCreate(sName, OBJ_ARROW, 0, Time[i], 0);
    if(ssName=="up")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  225);
    ObjectSet(sName, OBJPROP_PRICE1, Low[i]-5*Point);
    ObjectSet(sName, OBJPROP_COLOR, Lime);
    }
    if(ssName=="dn")
    {
    ObjectSet(sName, OBJPROP_ARROWCODE,  226);
    ObjectSet(sName, OBJPROP_PRICE1, High[i]+5*Point);
    ObjectSet(sName, OBJPROP_COLOR, Red);    
    }    
    ObjectSet(sName, OBJPROP_WIDTH, 1);
}  
  
//+------------------------------------------------------------------+
//| Trend                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i, CurrentBar, Bands_Mode, counted_bars = IndicatorCounted();
   double Power_Price, CurrentPrice,tmp,Range_level;
//----
   Range_level=range*Point;
   
   if(Bars <= Bands_Period) 
       return(0);
//---- initial zero
   if(counted_bars < Bands_Period)
     {
       for(i = 1; i <= Bands_Period; i++) 
       {
        value[Bars-i] = 0.0;
        value2[Bars-i] = 0.0;
        flat[Bars - i] = EMPTY_VALUE;
        up[Bars - i] = EMPTY_VALUE;
        dn[Bars - i] = EMPTY_VALUE;
       }
     }
//----
   i = CountBars - Bands_Period - 1;

   for(i = CountBars - 1; i >= 0; i--)
     {  
       value[i]=Close[i]-iBands(NULL,0,Bands_Period,Bands_Deviation,0,0,0,i);
       value2[i]=-(iBearsPower(NULL, 0, Power_Period,0,i)+
                   iBullsPower(NULL,0,Power_Period,0,i)); 
 
      if (value[i]>value2[i] && up[i]!=0.0)
      {
       if(value[i+1]<=value2[i+1])
       {
        up[i]=0.0;dn[i]=EMPTY_VALUE;        
       }
      }
      if (value[i]<value2[i]&& dn[i]!=0.0)
      {
       if(value[i+1]>=value2[i+1])
       {
        dn[i]=0.0;up[i]=EMPTY_VALUE;
       }
      }        
     
     if (value[i] < Range_level && value[i] > (-Range_level) && 
         value2[i]< Range_level && value2[i]> (-Range_level)) 
       temp[i] = 0;
      else 
       temp[i] = -0.00001;
      
      tmp = 0;      
      for (int y = i + Continue_Priod - 1; y >= i; y--) 
       tmp = MathMin(tmp, temp[y]);
      if (tmp == 0.0) 
       flat[i] = 0.0;
      else 
       flat[i] = EMPTY_VALUE;
     
      if(arrows)
      {
        if(up[i]==0.0 && flat[i]!=0.0)
        {
        DrawAr("up",i);
        }
        if(dn[i]==0.0 && flat[i]!=0.0)
        {
        DrawAr("dn",i);
        }      
       }
     
     } 
     
     if(up[0]==0.0 && flat[0]!=0.0 )
      SendAlert("buy");
     if(dn[0]==0.0 && flat[0]!=0.0 )
      SendAlert("sell");
  
   return(0);
  }
//+------------------------------------------------------------------+
void SendAlert(string txt) {
   if (Time[0] != tt) {
      if (SoundAlert) {
         if (txt == "buy") Alert("iTrend Long " + Symbol() + ", " + Period());
         if (txt == "sell") Alert("iTrend Short " + Symbol() + ", " + Period());
      }
      tt = Time[0];
   }
}